<a id="mypy-boto3-sagemaker"></a>

# mypy-boto3-sagemaker

[![PyPI - mypy-boto3-sagemaker](https://img.shields.io/pypi/v/mypy-boto3-sagemaker.svg?color=blue)](https://pypi.org/project/mypy-boto3-sagemaker)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-sagemaker.svg?color=blue)](https://pypi.org/project/mypy-boto3-sagemaker)
[![Docs](https://img.shields.io/readthedocs/boto3-stubs.svg?color=blue)](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_sagemaker/)
[![PyPI - Downloads](https://static.pepy.tech/badge/mypy-boto3-sagemaker)](https://pepy.tech/project/mypy-boto3-sagemaker)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.SageMaker 1.28.15](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/sagemaker.html#SageMaker)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.16.2](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-sagemaker docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_sagemaker/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-sagemaker](#mypy-boto3-sagemaker)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `SageMaker`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `SageMaker` service.

```bash
# install with boto3 type annotations
python -m pip install 'boto3-stubs[sagemaker]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'boto3-stubs-lite[sagemaker]'


# standalone installation
python -m pip install mypy-boto3-sagemaker
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y mypy-boto3-sagemaker
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto3-stubs[sagemaker]` in your environment:

```bash
python -m pip install 'boto3-stubs[sagemaker]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `boto3-stubs-lite[sagemaker]` in your environment:

```bash
python -m pip install 'boto3-stubs-lite[sagemaker]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `boto3-stubs` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `boto3-stubs` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[sagemaker]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed `boto3-stubs`

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `boto3-stubs[sagemaker]` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[sagemaker]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto3-stubs[sagemaker]` in your environment:

```bash
python -m pip install 'boto3-stubs[sagemaker]'`
```

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `boto3-stubs[sagemaker]` in your environment:

```bash
python -m pip install 'boto3-stubs[sagemaker]'
```

Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`SageMakerClient` provides annotations for `boto3.client("sagemaker")`.

```python
from boto3.session import Session

from mypy_boto3_sagemaker import SageMakerClient

client: SageMakerClient = Session().client("sagemaker")

# now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_sagemaker.paginator` module contains type annotations for all
paginators.

```python
from boto3.session import Session

from mypy_boto3_sagemaker import SageMakerClient
from mypy_boto3_sagemaker.paginator import (
    ListActionsPaginator,
    ListAlgorithmsPaginator,
    ListAliasesPaginator,
    ListAppImageConfigsPaginator,
    ListAppsPaginator,
    ListArtifactsPaginator,
    ListAssociationsPaginator,
    ListAutoMLJobsPaginator,
    ListCandidatesForAutoMLJobPaginator,
    ListCodeRepositoriesPaginator,
    ListCompilationJobsPaginator,
    ListContextsPaginator,
    ListDataQualityJobDefinitionsPaginator,
    ListDeviceFleetsPaginator,
    ListDevicesPaginator,
    ListDomainsPaginator,
    ListEdgeDeploymentPlansPaginator,
    ListEdgePackagingJobsPaginator,
    ListEndpointConfigsPaginator,
    ListEndpointsPaginator,
    ListExperimentsPaginator,
    ListFeatureGroupsPaginator,
    ListFlowDefinitionsPaginator,
    ListHumanTaskUisPaginator,
    ListHyperParameterTuningJobsPaginator,
    ListImageVersionsPaginator,
    ListImagesPaginator,
    ListInferenceExperimentsPaginator,
    ListInferenceRecommendationsJobStepsPaginator,
    ListInferenceRecommendationsJobsPaginator,
    ListLabelingJobsPaginator,
    ListLabelingJobsForWorkteamPaginator,
    ListLineageGroupsPaginator,
    ListModelBiasJobDefinitionsPaginator,
    ListModelCardExportJobsPaginator,
    ListModelCardVersionsPaginator,
    ListModelCardsPaginator,
    ListModelExplainabilityJobDefinitionsPaginator,
    ListModelMetadataPaginator,
    ListModelPackageGroupsPaginator,
    ListModelPackagesPaginator,
    ListModelQualityJobDefinitionsPaginator,
    ListModelsPaginator,
    ListMonitoringAlertHistoryPaginator,
    ListMonitoringAlertsPaginator,
    ListMonitoringExecutionsPaginator,
    ListMonitoringSchedulesPaginator,
    ListNotebookInstanceLifecycleConfigsPaginator,
    ListNotebookInstancesPaginator,
    ListPipelineExecutionStepsPaginator,
    ListPipelineExecutionsPaginator,
    ListPipelineParametersForExecutionPaginator,
    ListPipelinesPaginator,
    ListProcessingJobsPaginator,
    ListResourceCatalogsPaginator,
    ListSpacesPaginator,
    ListStageDevicesPaginator,
    ListStudioLifecycleConfigsPaginator,
    ListSubscribedWorkteamsPaginator,
    ListTagsPaginator,
    ListTrainingJobsPaginator,
    ListTrainingJobsForHyperParameterTuningJobPaginator,
    ListTransformJobsPaginator,
    ListTrialComponentsPaginator,
    ListTrialsPaginator,
    ListUserProfilesPaginator,
    ListWorkforcesPaginator,
    ListWorkteamsPaginator,
    SearchPaginator,
)

client: SageMakerClient = Session().client("sagemaker")

# Explicit type annotations are optional here
# Types should be correctly discovered by mypy and IDEs
list_actions_paginator: ListActionsPaginator = client.get_paginator("list_actions")
list_algorithms_paginator: ListAlgorithmsPaginator = client.get_paginator("list_algorithms")
list_aliases_paginator: ListAliasesPaginator = client.get_paginator("list_aliases")
list_app_image_configs_paginator: ListAppImageConfigsPaginator = client.get_paginator(
    "list_app_image_configs"
)
list_apps_paginator: ListAppsPaginator = client.get_paginator("list_apps")
list_artifacts_paginator: ListArtifactsPaginator = client.get_paginator("list_artifacts")
list_associations_paginator: ListAssociationsPaginator = client.get_paginator("list_associations")
list_auto_ml_jobs_paginator: ListAutoMLJobsPaginator = client.get_paginator("list_auto_ml_jobs")
list_candidates_for_auto_ml_job_paginator: ListCandidatesForAutoMLJobPaginator = (
    client.get_paginator("list_candidates_for_auto_ml_job")
)
list_code_repositories_paginator: ListCodeRepositoriesPaginator = client.get_paginator(
    "list_code_repositories"
)
list_compilation_jobs_paginator: ListCompilationJobsPaginator = client.get_paginator(
    "list_compilation_jobs"
)
list_contexts_paginator: ListContextsPaginator = client.get_paginator("list_contexts")
list_data_quality_job_definitions_paginator: ListDataQualityJobDefinitionsPaginator = (
    client.get_paginator("list_data_quality_job_definitions")
)
list_device_fleets_paginator: ListDeviceFleetsPaginator = client.get_paginator("list_device_fleets")
list_devices_paginator: ListDevicesPaginator = client.get_paginator("list_devices")
list_domains_paginator: ListDomainsPaginator = client.get_paginator("list_domains")
list_edge_deployment_plans_paginator: ListEdgeDeploymentPlansPaginator = client.get_paginator(
    "list_edge_deployment_plans"
)
list_edge_packaging_jobs_paginator: ListEdgePackagingJobsPaginator = client.get_paginator(
    "list_edge_packaging_jobs"
)
list_endpoint_configs_paginator: ListEndpointConfigsPaginator = client.get_paginator(
    "list_endpoint_configs"
)
list_endpoints_paginator: ListEndpointsPaginator = client.get_paginator("list_endpoints")
list_experiments_paginator: ListExperimentsPaginator = client.get_paginator("list_experiments")
list_feature_groups_paginator: ListFeatureGroupsPaginator = client.get_paginator(
    "list_feature_groups"
)
list_flow_definitions_paginator: ListFlowDefinitionsPaginator = client.get_paginator(
    "list_flow_definitions"
)
list_human_task_uis_paginator: ListHumanTaskUisPaginator = client.get_paginator(
    "list_human_task_uis"
)
list_hyper_parameter_tuning_jobs_paginator: ListHyperParameterTuningJobsPaginator = (
    client.get_paginator("list_hyper_parameter_tuning_jobs")
)
list_image_versions_paginator: ListImageVersionsPaginator = client.get_paginator(
    "list_image_versions"
)
list_images_paginator: ListImagesPaginator = client.get_paginator("list_images")
list_inference_experiments_paginator: ListInferenceExperimentsPaginator = client.get_paginator(
    "list_inference_experiments"
)
list_inference_recommendations_job_steps_paginator: ListInferenceRecommendationsJobStepsPaginator = client.get_paginator(
    "list_inference_recommendations_job_steps"
)
list_inference_recommendations_jobs_paginator: ListInferenceRecommendationsJobsPaginator = (
    client.get_paginator("list_inference_recommendations_jobs")
)
list_labeling_jobs_paginator: ListLabelingJobsPaginator = client.get_paginator("list_labeling_jobs")
list_labeling_jobs_for_workteam_paginator: ListLabelingJobsForWorkteamPaginator = (
    client.get_paginator("list_labeling_jobs_for_workteam")
)
list_lineage_groups_paginator: ListLineageGroupsPaginator = client.get_paginator(
    "list_lineage_groups"
)
list_model_bias_job_definitions_paginator: ListModelBiasJobDefinitionsPaginator = (
    client.get_paginator("list_model_bias_job_definitions")
)
list_model_card_export_jobs_paginator: ListModelCardExportJobsPaginator = client.get_paginator(
    "list_model_card_export_jobs"
)
list_model_card_versions_paginator: ListModelCardVersionsPaginator = client.get_paginator(
    "list_model_card_versions"
)
list_model_cards_paginator: ListModelCardsPaginator = client.get_paginator("list_model_cards")
list_model_explainability_job_definitions_paginator: ListModelExplainabilityJobDefinitionsPaginator = client.get_paginator(
    "list_model_explainability_job_definitions"
)
list_model_metadata_paginator: ListModelMetadataPaginator = client.get_paginator(
    "list_model_metadata"
)
list_model_package_groups_paginator: ListModelPackageGroupsPaginator = client.get_paginator(
    "list_model_package_groups"
)
list_model_packages_paginator: ListModelPackagesPaginator = client.get_paginator(
    "list_model_packages"
)
list_model_quality_job_definitions_paginator: ListModelQualityJobDefinitionsPaginator = (
    client.get_paginator("list_model_quality_job_definitions")
)
list_models_paginator: ListModelsPaginator = client.get_paginator("list_models")
list_monitoring_alert_history_paginator: ListMonitoringAlertHistoryPaginator = client.get_paginator(
    "list_monitoring_alert_history"
)
list_monitoring_alerts_paginator: ListMonitoringAlertsPaginator = client.get_paginator(
    "list_monitoring_alerts"
)
list_monitoring_executions_paginator: ListMonitoringExecutionsPaginator = client.get_paginator(
    "list_monitoring_executions"
)
list_monitoring_schedules_paginator: ListMonitoringSchedulesPaginator = client.get_paginator(
    "list_monitoring_schedules"
)
list_notebook_instance_lifecycle_configs_paginator: ListNotebookInstanceLifecycleConfigsPaginator = client.get_paginator(
    "list_notebook_instance_lifecycle_configs"
)
list_notebook_instances_paginator: ListNotebookInstancesPaginator = client.get_paginator(
    "list_notebook_instances"
)
list_pipeline_execution_steps_paginator: ListPipelineExecutionStepsPaginator = client.get_paginator(
    "list_pipeline_execution_steps"
)
list_pipeline_executions_paginator: ListPipelineExecutionsPaginator = client.get_paginator(
    "list_pipeline_executions"
)
list_pipeline_parameters_for_execution_paginator: ListPipelineParametersForExecutionPaginator = (
    client.get_paginator("list_pipeline_parameters_for_execution")
)
list_pipelines_paginator: ListPipelinesPaginator = client.get_paginator("list_pipelines")
list_processing_jobs_paginator: ListProcessingJobsPaginator = client.get_paginator(
    "list_processing_jobs"
)
list_resource_catalogs_paginator: ListResourceCatalogsPaginator = client.get_paginator(
    "list_resource_catalogs"
)
list_spaces_paginator: ListSpacesPaginator = client.get_paginator("list_spaces")
list_stage_devices_paginator: ListStageDevicesPaginator = client.get_paginator("list_stage_devices")
list_studio_lifecycle_configs_paginator: ListStudioLifecycleConfigsPaginator = client.get_paginator(
    "list_studio_lifecycle_configs"
)
list_subscribed_workteams_paginator: ListSubscribedWorkteamsPaginator = client.get_paginator(
    "list_subscribed_workteams"
)
list_tags_paginator: ListTagsPaginator = client.get_paginator("list_tags")
list_training_jobs_paginator: ListTrainingJobsPaginator = client.get_paginator("list_training_jobs")
list_training_jobs_for_hyper_parameter_tuning_job_paginator: ListTrainingJobsForHyperParameterTuningJobPaginator = client.get_paginator(
    "list_training_jobs_for_hyper_parameter_tuning_job"
)
list_transform_jobs_paginator: ListTransformJobsPaginator = client.get_paginator(
    "list_transform_jobs"
)
list_trial_components_paginator: ListTrialComponentsPaginator = client.get_paginator(
    "list_trial_components"
)
list_trials_paginator: ListTrialsPaginator = client.get_paginator("list_trials")
list_user_profiles_paginator: ListUserProfilesPaginator = client.get_paginator("list_user_profiles")
list_workforces_paginator: ListWorkforcesPaginator = client.get_paginator("list_workforces")
list_workteams_paginator: ListWorkteamsPaginator = client.get_paginator("list_workteams")
search_paginator: SearchPaginator = client.get_paginator("search")
```

<a id="waiters-annotations"></a>

### Waiters annotations

`mypy_boto3_sagemaker.waiter` module contains type annotations for all waiters.

```python
from boto3.session import Session

from mypy_boto3_sagemaker import SageMakerClient
from mypy_boto3_sagemaker.waiter import (
    EndpointDeletedWaiter,
    EndpointInServiceWaiter,
    ImageCreatedWaiter,
    ImageDeletedWaiter,
    ImageUpdatedWaiter,
    ImageVersionCreatedWaiter,
    ImageVersionDeletedWaiter,
    NotebookInstanceDeletedWaiter,
    NotebookInstanceInServiceWaiter,
    NotebookInstanceStoppedWaiter,
    ProcessingJobCompletedOrStoppedWaiter,
    TrainingJobCompletedOrStoppedWaiter,
    TransformJobCompletedOrStoppedWaiter,
)

client: SageMakerClient = Session().client("sagemaker")

# Explicit type annotations are optional here
# Types should be correctly discovered by mypy and IDEs
endpoint_deleted_waiter: EndpointDeletedWaiter = client.get_waiter("endpoint_deleted")
endpoint_in_service_waiter: EndpointInServiceWaiter = client.get_waiter("endpoint_in_service")
image_created_waiter: ImageCreatedWaiter = client.get_waiter("image_created")
image_deleted_waiter: ImageDeletedWaiter = client.get_waiter("image_deleted")
image_updated_waiter: ImageUpdatedWaiter = client.get_waiter("image_updated")
image_version_created_waiter: ImageVersionCreatedWaiter = client.get_waiter("image_version_created")
image_version_deleted_waiter: ImageVersionDeletedWaiter = client.get_waiter("image_version_deleted")
notebook_instance_deleted_waiter: NotebookInstanceDeletedWaiter = client.get_waiter(
    "notebook_instance_deleted"
)
notebook_instance_in_service_waiter: NotebookInstanceInServiceWaiter = client.get_waiter(
    "notebook_instance_in_service"
)
notebook_instance_stopped_waiter: NotebookInstanceStoppedWaiter = client.get_waiter(
    "notebook_instance_stopped"
)
processing_job_completed_or_stopped_waiter: ProcessingJobCompletedOrStoppedWaiter = (
    client.get_waiter("processing_job_completed_or_stopped")
)
training_job_completed_or_stopped_waiter: TrainingJobCompletedOrStoppedWaiter = client.get_waiter(
    "training_job_completed_or_stopped"
)
transform_job_completed_or_stopped_waiter: TransformJobCompletedOrStoppedWaiter = client.get_waiter(
    "transform_job_completed_or_stopped"
)
```

<a id="literals"></a>

### Literals

`mypy_boto3_sagemaker.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from mypy_boto3_sagemaker.literals import (
    ActionStatusType,
    AggregationTransformationValueType,
    AlgorithmSortByType,
    AlgorithmStatusType,
    AppImageConfigSortKeyType,
    AppInstanceTypeType,
    AppNetworkAccessTypeType,
    AppSecurityGroupManagementType,
    AppSortKeyType,
    AppStatusType,
    AppTypeType,
    ArtifactSourceIdTypeType,
    AssemblyTypeType,
    AssociationEdgeTypeType,
    AsyncNotificationTopicTypesType,
    AthenaResultCompressionTypeType,
    AthenaResultFormatType,
    AuthModeType,
    AutoMLAlgorithmType,
    AutoMLChannelTypeType,
    AutoMLJobObjectiveTypeType,
    AutoMLJobSecondaryStatusType,
    AutoMLJobStatusType,
    AutoMLMetricEnumType,
    AutoMLMetricExtendedEnumType,
    AutoMLModeType,
    AutoMLProblemTypeConfigNameType,
    AutoMLProcessingUnitType,
    AutoMLS3DataTypeType,
    AutoMLSortByType,
    AutoMLSortOrderType,
    AutotuneModeType,
    AwsManagedHumanLoopRequestSourceType,
    BatchStrategyType,
    BooleanOperatorType,
    CandidateSortByType,
    CandidateStatusType,
    CandidateStepTypeType,
    CapacitySizeTypeType,
    CaptureModeType,
    CaptureStatusType,
    ClarifyFeatureTypeType,
    ClarifyTextGranularityType,
    ClarifyTextLanguageType,
    CodeRepositorySortByType,
    CodeRepositorySortOrderType,
    CompilationJobStatusType,
    CompleteOnConvergenceType,
    CompressionTypeType,
    ConditionOutcomeType,
    ContainerModeType,
    ContentClassifierType,
    CrossAccountFilterOptionType,
    DataDistributionTypeType,
    DetailedAlgorithmStatusType,
    DetailedModelPackageStatusType,
    DeviceDeploymentStatusType,
    DeviceSubsetTypeType,
    DirectInternetAccessType,
    DirectionType,
    DomainStatusType,
    EdgePackagingJobStatusType,
    EdgePresetDeploymentStatusType,
    EdgePresetDeploymentTypeType,
    EndpointConfigSortKeyType,
    EndpointDeletedWaiterName,
    EndpointInServiceWaiterName,
    EndpointSortKeyType,
    EndpointStatusType,
    ExecutionRoleIdentityConfigType,
    ExecutionStatusType,
    FailureHandlingPolicyType,
    FeatureGroupSortByType,
    FeatureGroupSortOrderType,
    FeatureGroupStatusType,
    FeatureStatusType,
    FeatureTypeType,
    FileSystemAccessModeType,
    FileSystemTypeType,
    FillingTypeType,
    FlowDefinitionStatusType,
    FrameworkType,
    HubContentSortByType,
    HubContentStatusType,
    HubContentTypeType,
    HubSortByType,
    HubStatusType,
    HumanTaskUiStatusType,
    HyperParameterScalingTypeType,
    HyperParameterTuningAllocationStrategyType,
    HyperParameterTuningJobObjectiveTypeType,
    HyperParameterTuningJobSortByOptionsType,
    HyperParameterTuningJobStatusType,
    HyperParameterTuningJobStrategyTypeType,
    HyperParameterTuningJobWarmStartTypeType,
    ImageCreatedWaiterName,
    ImageDeletedWaiterName,
    ImageSortByType,
    ImageSortOrderType,
    ImageStatusType,
    ImageUpdatedWaiterName,
    ImageVersionCreatedWaiterName,
    ImageVersionDeletedWaiterName,
    ImageVersionSortByType,
    ImageVersionSortOrderType,
    ImageVersionStatusType,
    InferenceExecutionModeType,
    InferenceExperimentStatusType,
    InferenceExperimentStopDesiredStateType,
    InferenceExperimentTypeType,
    InputModeType,
    InstanceTypeType,
    JobTypeType,
    JoinSourceType,
    LabelingJobStatusType,
    LastUpdateStatusValueType,
    LineageTypeType,
    ListActionsPaginatorName,
    ListAlgorithmsPaginatorName,
    ListAliasesPaginatorName,
    ListAppImageConfigsPaginatorName,
    ListAppsPaginatorName,
    ListArtifactsPaginatorName,
    ListAssociationsPaginatorName,
    ListAutoMLJobsPaginatorName,
    ListCandidatesForAutoMLJobPaginatorName,
    ListCodeRepositoriesPaginatorName,
    ListCompilationJobsPaginatorName,
    ListCompilationJobsSortByType,
    ListContextsPaginatorName,
    ListDataQualityJobDefinitionsPaginatorName,
    ListDeviceFleetsPaginatorName,
    ListDeviceFleetsSortByType,
    ListDevicesPaginatorName,
    ListDomainsPaginatorName,
    ListEdgeDeploymentPlansPaginatorName,
    ListEdgeDeploymentPlansSortByType,
    ListEdgePackagingJobsPaginatorName,
    ListEdgePackagingJobsSortByType,
    ListEndpointConfigsPaginatorName,
    ListEndpointsPaginatorName,
    ListExperimentsPaginatorName,
    ListFeatureGroupsPaginatorName,
    ListFlowDefinitionsPaginatorName,
    ListHumanTaskUisPaginatorName,
    ListHyperParameterTuningJobsPaginatorName,
    ListImageVersionsPaginatorName,
    ListImagesPaginatorName,
    ListInferenceExperimentsPaginatorName,
    ListInferenceRecommendationsJobStepsPaginatorName,
    ListInferenceRecommendationsJobsPaginatorName,
    ListInferenceRecommendationsJobsSortByType,
    ListLabelingJobsForWorkteamPaginatorName,
    ListLabelingJobsForWorkteamSortByOptionsType,
    ListLabelingJobsPaginatorName,
    ListLineageGroupsPaginatorName,
    ListModelBiasJobDefinitionsPaginatorName,
    ListModelCardExportJobsPaginatorName,
    ListModelCardVersionsPaginatorName,
    ListModelCardsPaginatorName,
    ListModelExplainabilityJobDefinitionsPaginatorName,
    ListModelMetadataPaginatorName,
    ListModelPackageGroupsPaginatorName,
    ListModelPackagesPaginatorName,
    ListModelQualityJobDefinitionsPaginatorName,
    ListModelsPaginatorName,
    ListMonitoringAlertHistoryPaginatorName,
    ListMonitoringAlertsPaginatorName,
    ListMonitoringExecutionsPaginatorName,
    ListMonitoringSchedulesPaginatorName,
    ListNotebookInstanceLifecycleConfigsPaginatorName,
    ListNotebookInstancesPaginatorName,
    ListPipelineExecutionStepsPaginatorName,
    ListPipelineExecutionsPaginatorName,
    ListPipelineParametersForExecutionPaginatorName,
    ListPipelinesPaginatorName,
    ListProcessingJobsPaginatorName,
    ListResourceCatalogsPaginatorName,
    ListSpacesPaginatorName,
    ListStageDevicesPaginatorName,
    ListStudioLifecycleConfigsPaginatorName,
    ListSubscribedWorkteamsPaginatorName,
    ListTagsPaginatorName,
    ListTrainingJobsForHyperParameterTuningJobPaginatorName,
    ListTrainingJobsPaginatorName,
    ListTransformJobsPaginatorName,
    ListTrialComponentsPaginatorName,
    ListTrialsPaginatorName,
    ListUserProfilesPaginatorName,
    ListWorkforcesPaginatorName,
    ListWorkforcesSortByOptionsType,
    ListWorkteamsPaginatorName,
    ListWorkteamsSortByOptionsType,
    MetricSetSourceType,
    ModelApprovalStatusType,
    ModelCacheSettingType,
    ModelCardExportJobSortByType,
    ModelCardExportJobSortOrderType,
    ModelCardExportJobStatusType,
    ModelCardProcessingStatusType,
    ModelCardSortByType,
    ModelCardSortOrderType,
    ModelCardStatusType,
    ModelCardVersionSortByType,
    ModelCompressionTypeType,
    ModelInfrastructureTypeType,
    ModelMetadataFilterTypeType,
    ModelPackageGroupSortByType,
    ModelPackageGroupStatusType,
    ModelPackageSortByType,
    ModelPackageStatusType,
    ModelPackageTypeType,
    ModelSortKeyType,
    ModelVariantActionType,
    ModelVariantStatusType,
    MonitoringAlertHistorySortKeyType,
    MonitoringAlertStatusType,
    MonitoringExecutionSortKeyType,
    MonitoringJobDefinitionSortKeyType,
    MonitoringProblemTypeType,
    MonitoringScheduleSortKeyType,
    MonitoringTypeType,
    NotebookInstanceAcceleratorTypeType,
    NotebookInstanceDeletedWaiterName,
    NotebookInstanceInServiceWaiterName,
    NotebookInstanceLifecycleConfigSortKeyType,
    NotebookInstanceLifecycleConfigSortOrderType,
    NotebookInstanceSortKeyType,
    NotebookInstanceSortOrderType,
    NotebookInstanceStatusType,
    NotebookInstanceStoppedWaiterName,
    NotebookOutputOptionType,
    ObjectiveStatusType,
    OfflineStoreStatusValueType,
    OperatorType,
    OrderKeyType,
    OutputCompressionTypeType,
    ParameterTypeType,
    PipelineExecutionStatusType,
    PipelineStatusType,
    ProblemTypeType,
    ProcessingInstanceTypeType,
    ProcessingJobCompletedOrStoppedWaiterName,
    ProcessingJobStatusType,
    ProcessingS3CompressionTypeType,
    ProcessingS3DataDistributionTypeType,
    ProcessingS3DataTypeType,
    ProcessingS3InputModeType,
    ProcessingS3UploadModeType,
    ProcessorType,
    ProductionVariantAcceleratorTypeType,
    ProductionVariantInstanceTypeType,
    ProfilingStatusType,
    ProjectSortByType,
    ProjectSortOrderType,
    ProjectStatusType,
    RStudioServerProAccessStatusType,
    RStudioServerProUserGroupType,
    RecommendationJobStatusType,
    RecommendationJobSupportedEndpointTypeType,
    RecommendationJobTypeType,
    RecommendationStatusType,
    RecommendationStepTypeType,
    RecordWrapperType,
    RedshiftResultCompressionTypeType,
    RedshiftResultFormatType,
    RepositoryAccessModeType,
    ResourceCatalogSortByType,
    ResourceCatalogSortOrderType,
    ResourceTypeType,
    RetentionTypeType,
    RootAccessType,
    RuleEvaluationStatusType,
    S3DataDistributionType,
    S3DataTypeType,
    S3ModelDataTypeType,
    SagemakerServicecatalogStatusType,
    ScheduleStatusType,
    SearchPaginatorName,
    SearchSortOrderType,
    SecondaryStatusType,
    SortActionsByType,
    SortArtifactsByType,
    SortAssociationsByType,
    SortByType,
    SortContextsByType,
    SortExperimentsByType,
    SortInferenceExperimentsByType,
    SortLineageGroupsByType,
    SortOrderType,
    SortPipelineExecutionsByType,
    SortPipelinesByType,
    SortTrialComponentsByType,
    SortTrialsByType,
    SpaceSortKeyType,
    SpaceStatusType,
    SplitTypeType,
    StageStatusType,
    StepStatusType,
    StudioLifecycleConfigAppTypeType,
    StudioLifecycleConfigSortKeyType,
    TableFormatType,
    TargetDeviceType,
    TargetPlatformAcceleratorType,
    TargetPlatformArchType,
    TargetPlatformOsType,
    TrafficRoutingConfigTypeType,
    TrafficTypeType,
    TrainingInputModeType,
    TrainingInstanceTypeType,
    TrainingJobCompletedOrStoppedWaiterName,
    TrainingJobEarlyStoppingTypeType,
    TrainingJobSortByOptionsType,
    TrainingJobStatusType,
    TrainingRepositoryAccessModeType,
    TransformInstanceTypeType,
    TransformJobCompletedOrStoppedWaiterName,
    TransformJobStatusType,
    TrialComponentPrimaryStatusType,
    TtlDurationUnitType,
    UserProfileSortKeyType,
    UserProfileStatusType,
    VariantPropertyTypeType,
    VariantStatusType,
    VendorGuidanceType,
    WarmPoolResourceStatusType,
    WorkforceStatusType,
    SageMakerServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    WaiterName,
    RegionName,
)


def check_value(value: ActionStatusType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_sagemaker.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_sagemaker.type_defs import (
    ActionSourceTypeDef,
    AddAssociationRequestRequestTypeDef,
    ResponseMetadataTypeDef,
    TagTypeDef,
    AgentVersionTypeDef,
    AlarmTypeDef,
    MetricDefinitionTypeDef,
    AlgorithmStatusItemTypeDef,
    AlgorithmSummaryTypeDef,
    AnnotationConsolidationConfigTypeDef,
    AppDetailsTypeDef,
    AppSpecificationOutputTypeDef,
    AppSpecificationTypeDef,
    ArtifactSourceTypeTypeDef,
    AssociateTrialComponentRequestRequestTypeDef,
    AsyncInferenceClientConfigTypeDef,
    AsyncInferenceNotificationConfigOutputTypeDef,
    AsyncInferenceNotificationConfigTypeDef,
    AthenaDatasetDefinitionTypeDef,
    AutoMLAlgorithmConfigOutputTypeDef,
    AutoMLAlgorithmConfigTypeDef,
    AutoMLCandidateStepTypeDef,
    AutoMLContainerDefinitionTypeDef,
    FinalAutoMLJobObjectiveMetricTypeDef,
    AutoMLS3DataSourceTypeDef,
    AutoMLDataSplitConfigTypeDef,
    AutoMLJobArtifactsTypeDef,
    AutoMLJobCompletionCriteriaTypeDef,
    AutoMLJobObjectiveTypeDef,
    AutoMLJobStepMetadataTypeDef,
    AutoMLPartialFailureReasonTypeDef,
    AutoMLOutputDataConfigTypeDef,
    TabularResolvedAttributesTypeDef,
    VpcConfigOutputTypeDef,
    VpcConfigTypeDef,
    AutoParameterTypeDef,
    AutotuneTypeDef,
    BatchDataCaptureConfigTypeDef,
    BatchDescribeModelPackageErrorTypeDef,
    BatchDescribeModelPackageInputRequestTypeDef,
    BestObjectiveNotImprovingTypeDef,
    MetricsSourceTypeDef,
    CacheHitResultTypeDef,
    OutputParameterTypeDef,
    CandidateArtifactLocationsTypeDef,
    MetricDatumTypeDef,
    ModelRegisterSettingsTypeDef,
    TimeSeriesForecastingSettingsTypeDef,
    WorkspaceSettingsTypeDef,
    CapacitySizeTypeDef,
    CaptureContentTypeHeaderOutputTypeDef,
    CaptureContentTypeHeaderTypeDef,
    CaptureOptionTypeDef,
    CategoricalParameterOutputTypeDef,
    CategoricalParameterRangeOutputTypeDef,
    CategoricalParameterRangeSpecificationOutputTypeDef,
    CategoricalParameterRangeSpecificationTypeDef,
    CategoricalParameterRangeTypeDef,
    CategoricalParameterTypeDef,
    ShuffleConfigTypeDef,
    ChannelSpecificationOutputTypeDef,
    ChannelSpecificationTypeDef,
    CheckpointConfigTypeDef,
    ClarifyCheckStepMetadataTypeDef,
    ClarifyInferenceConfigOutputTypeDef,
    ClarifyInferenceConfigTypeDef,
    ClarifyShapBaselineConfigTypeDef,
    ClarifyTextConfigTypeDef,
    GitConfigTypeDef,
    CodeRepositoryTypeDef,
    CognitoConfigTypeDef,
    CognitoMemberDefinitionTypeDef,
    CollectionConfigurationOutputTypeDef,
    CollectionConfigurationTypeDef,
    CompilationJobSummaryTypeDef,
    ConditionStepMetadataTypeDef,
    MultiModelConfigTypeDef,
    ContextSourceTypeDef,
    ContinuousParameterRangeSpecificationTypeDef,
    ContinuousParameterRangeTypeDef,
    ConvergenceDetectedTypeDef,
    MetadataPropertiesTypeDef,
    ResourceSpecTypeDef,
    ModelDeployConfigTypeDef,
    InputConfigTypeDef,
    NeoVpcConfigTypeDef,
    StoppingConditionTypeDef,
    DataQualityAppSpecificationTypeDef,
    MonitoringStoppingConditionTypeDef,
    EdgeOutputConfigTypeDef,
    EdgeDeploymentModelConfigTypeDef,
    FeatureDefinitionTypeDef,
    FlowDefinitionOutputConfigTypeDef,
    HumanLoopRequestSourceTypeDef,
    HubS3StorageConfigTypeDef,
    UiTemplateTypeDef,
    CreateImageVersionRequestRequestTypeDef,
    InferenceExperimentScheduleTypeDef,
    LabelingJobOutputConfigTypeDef,
    LabelingJobStoppingConditionsTypeDef,
    ModelBiasAppSpecificationTypeDef,
    ModelCardExportOutputConfigTypeDef,
    ModelCardSecurityConfigTypeDef,
    ModelExplainabilityAppSpecificationTypeDef,
    InferenceExecutionConfigTypeDef,
    ModelQualityAppSpecificationTypeDef,
    InstanceMetadataServiceConfigurationTypeDef,
    NotebookInstanceLifecycleHookTypeDef,
    ParallelismConfigurationTypeDef,
    PipelineDefinitionS3LocationTypeDef,
    CreatePresignedDomainUrlRequestRequestTypeDef,
    CreatePresignedNotebookInstanceUrlInputRequestTypeDef,
    ExperimentConfigTypeDef,
    ProcessingStoppingConditionTypeDef,
    DebugRuleConfigurationOutputTypeDef,
    DebugRuleConfigurationTypeDef,
    OutputDataConfigTypeDef,
    ProfilerConfigTypeDef,
    ProfilerRuleConfigurationOutputTypeDef,
    ProfilerRuleConfigurationTypeDef,
    RetryStrategyTypeDef,
    TensorBoardOutputConfigTypeDef,
    DataProcessingTypeDef,
    ModelClientConfigTypeDef,
    TransformOutputTypeDef,
    TransformResourcesTypeDef,
    TrialComponentArtifactTypeDef,
    TrialComponentParameterValueTypeDef,
    TrialComponentStatusTypeDef,
    OidcConfigTypeDef,
    SourceIpConfigTypeDef,
    WorkforceVpcConfigRequestTypeDef,
    NotificationConfigurationTypeDef,
    CustomImageTypeDef,
    DataCaptureConfigSummaryTypeDef,
    DataCatalogConfigTypeDef,
    DataQualityAppSpecificationOutputTypeDef,
    MonitoringConstraintsResourceTypeDef,
    MonitoringStatisticsResourceTypeDef,
    EndpointInputTypeDef,
    FileSystemDataSourceTypeDef,
    S3DataSourceOutputTypeDef,
    S3DataSourceTypeDef,
    RedshiftDatasetDefinitionTypeDef,
    DebugRuleEvaluationStatusTypeDef,
    DeleteActionRequestRequestTypeDef,
    DeleteAlgorithmInputRequestTypeDef,
    DeleteAppImageConfigRequestRequestTypeDef,
    DeleteAppRequestRequestTypeDef,
    DeleteAssociationRequestRequestTypeDef,
    DeleteCodeRepositoryInputRequestTypeDef,
    DeleteContextRequestRequestTypeDef,
    DeleteDataQualityJobDefinitionRequestRequestTypeDef,
    DeleteDeviceFleetRequestRequestTypeDef,
    RetentionPolicyTypeDef,
    DeleteEdgeDeploymentPlanRequestRequestTypeDef,
    DeleteEdgeDeploymentStageRequestRequestTypeDef,
    DeleteEndpointConfigInputRequestTypeDef,
    DeleteEndpointInputRequestTypeDef,
    DeleteExperimentRequestRequestTypeDef,
    DeleteFeatureGroupRequestRequestTypeDef,
    DeleteFlowDefinitionRequestRequestTypeDef,
    DeleteHubContentRequestRequestTypeDef,
    DeleteHubRequestRequestTypeDef,
    DeleteHumanTaskUiRequestRequestTypeDef,
    DeleteImageRequestRequestTypeDef,
    DeleteImageVersionRequestRequestTypeDef,
    DeleteInferenceExperimentRequestRequestTypeDef,
    DeleteModelBiasJobDefinitionRequestRequestTypeDef,
    DeleteModelCardRequestRequestTypeDef,
    DeleteModelExplainabilityJobDefinitionRequestRequestTypeDef,
    DeleteModelInputRequestTypeDef,
    DeleteModelPackageGroupInputRequestTypeDef,
    DeleteModelPackageGroupPolicyInputRequestTypeDef,
    DeleteModelPackageInputRequestTypeDef,
    DeleteModelQualityJobDefinitionRequestRequestTypeDef,
    DeleteMonitoringScheduleRequestRequestTypeDef,
    DeleteNotebookInstanceInputRequestTypeDef,
    DeleteNotebookInstanceLifecycleConfigInputRequestTypeDef,
    DeletePipelineRequestRequestTypeDef,
    DeleteProjectInputRequestTypeDef,
    DeleteSpaceRequestRequestTypeDef,
    DeleteStudioLifecycleConfigRequestRequestTypeDef,
    DeleteTagsInputRequestTypeDef,
    DeleteTrialComponentRequestRequestTypeDef,
    DeleteTrialRequestRequestTypeDef,
    DeleteUserProfileRequestRequestTypeDef,
    DeleteWorkforceRequestRequestTypeDef,
    DeleteWorkteamRequestRequestTypeDef,
    DeployedImageTypeDef,
    RealTimeInferenceRecommendationTypeDef,
    DeviceSelectionConfigOutputTypeDef,
    EdgeDeploymentConfigTypeDef,
    EdgeDeploymentStatusTypeDef,
    DeviceSelectionConfigTypeDef,
    DeregisterDevicesRequestRequestTypeDef,
    DescribeActionRequestRequestTypeDef,
    DescribeAlgorithmInputRequestTypeDef,
    DescribeAppImageConfigRequestRequestTypeDef,
    DescribeAppRequestRequestTypeDef,
    DescribeArtifactRequestRequestTypeDef,
    DescribeAutoMLJobRequestRequestTypeDef,
    ModelDeployResultTypeDef,
    DescribeAutoMLJobV2RequestRequestTypeDef,
    DescribeCodeRepositoryInputRequestTypeDef,
    DescribeCompilationJobRequestRequestTypeDef,
    ModelArtifactsTypeDef,
    ModelDigestsTypeDef,
    NeoVpcConfigOutputTypeDef,
    DescribeContextRequestRequestTypeDef,
    DescribeDataQualityJobDefinitionRequestRequestTypeDef,
    DescribeDeviceFleetRequestRequestTypeDef,
    DescribeDeviceRequestRequestTypeDef,
    EdgeModelTypeDef,
    DescribeDomainRequestRequestTypeDef,
    DescribeEdgeDeploymentPlanRequestRequestTypeDef,
    DescribeEdgePackagingJobRequestRequestTypeDef,
    EdgePresetDeploymentOutputTypeDef,
    DescribeEndpointConfigInputRequestTypeDef,
    WaiterConfigTypeDef,
    DescribeEndpointInputRequestTypeDef,
    DescribeExperimentRequestRequestTypeDef,
    ExperimentSourceTypeDef,
    DescribeFeatureGroupRequestRequestTypeDef,
    LastUpdateStatusTypeDef,
    OfflineStoreStatusTypeDef,
    DescribeFeatureMetadataRequestRequestTypeDef,
    FeatureParameterTypeDef,
    DescribeFlowDefinitionRequestRequestTypeDef,
    DescribeHubContentRequestRequestTypeDef,
    HubContentDependencyTypeDef,
    DescribeHubRequestRequestTypeDef,
    DescribeHumanTaskUiRequestRequestTypeDef,
    UiTemplateInfoTypeDef,
    DescribeHyperParameterTuningJobRequestRequestTypeDef,
    HyperParameterTuningJobCompletionDetailsTypeDef,
    HyperParameterTuningJobConsumedResourcesTypeDef,
    ObjectiveStatusCountersTypeDef,
    TrainingJobStatusCountersTypeDef,
    DescribeImageRequestRequestTypeDef,
    DescribeImageVersionRequestRequestTypeDef,
    DescribeInferenceExperimentRequestRequestTypeDef,
    EndpointMetadataTypeDef,
    InferenceExperimentScheduleOutputTypeDef,
    DescribeInferenceRecommendationsJobRequestRequestTypeDef,
    DescribeLabelingJobRequestRequestTypeDef,
    LabelCountersTypeDef,
    LabelingJobOutputTypeDef,
    DescribeLineageGroupRequestRequestTypeDef,
    DescribeModelBiasJobDefinitionRequestRequestTypeDef,
    ModelBiasAppSpecificationOutputTypeDef,
    DescribeModelCardExportJobRequestRequestTypeDef,
    ModelCardExportArtifactsTypeDef,
    DescribeModelCardRequestRequestTypeDef,
    DescribeModelExplainabilityJobDefinitionRequestRequestTypeDef,
    ModelExplainabilityAppSpecificationOutputTypeDef,
    DescribeModelInputRequestTypeDef,
    DescribeModelPackageGroupInputRequestTypeDef,
    DescribeModelPackageInputRequestTypeDef,
    DescribeModelQualityJobDefinitionRequestRequestTypeDef,
    ModelQualityAppSpecificationOutputTypeDef,
    DescribeMonitoringScheduleRequestRequestTypeDef,
    MonitoringExecutionSummaryTypeDef,
    DescribeNotebookInstanceInputRequestTypeDef,
    DescribeNotebookInstanceLifecycleConfigInputRequestTypeDef,
    DescribePipelineDefinitionForExecutionRequestRequestTypeDef,
    DescribePipelineExecutionRequestRequestTypeDef,
    PipelineExperimentConfigTypeDef,
    DescribePipelineRequestRequestTypeDef,
    DescribeProcessingJobRequestRequestTypeDef,
    DescribeProjectInputRequestTypeDef,
    ServiceCatalogProvisionedProductDetailsTypeDef,
    DescribeSpaceRequestRequestTypeDef,
    DescribeStudioLifecycleConfigRequestRequestTypeDef,
    DescribeSubscribedWorkteamRequestRequestTypeDef,
    SubscribedWorkteamTypeDef,
    DescribeTrainingJobRequestRequestTypeDef,
    MetricDataTypeDef,
    ProfilerConfigOutputTypeDef,
    ProfilerRuleEvaluationStatusTypeDef,
    SecondaryStatusTransitionTypeDef,
    WarmPoolStatusTypeDef,
    DescribeTransformJobRequestRequestTypeDef,
    DescribeTrialComponentRequestRequestTypeDef,
    TrialComponentMetricSummaryTypeDef,
    TrialComponentSourceTypeDef,
    DescribeTrialRequestRequestTypeDef,
    TrialSourceTypeDef,
    DescribeUserProfileRequestRequestTypeDef,
    DescribeWorkforceRequestRequestTypeDef,
    DescribeWorkteamRequestRequestTypeDef,
    ProductionVariantServerlessUpdateConfigTypeDef,
    DeviceDeploymentSummaryTypeDef,
    DeviceFleetSummaryTypeDef,
    DeviceStatsTypeDef,
    EdgeModelSummaryTypeDef,
    DeviceTypeDef,
    DisassociateTrialComponentRequestRequestTypeDef,
    DomainDetailsTypeDef,
    FileSourceTypeDef,
    EMRStepMetadataTypeDef,
    EdgeDeploymentPlanSummaryTypeDef,
    EdgeModelStatTypeDef,
    EdgePackagingJobSummaryTypeDef,
    EdgeTypeDef,
    EndpointConfigSummaryTypeDef,
    EndpointInfoTypeDef,
    ProductionVariantServerlessConfigTypeDef,
    InferenceMetricsTypeDef,
    EndpointSummaryTypeDef,
    EnvironmentParameterTypeDef,
    FailStepMetadataTypeDef,
    FileSystemConfigTypeDef,
    FilterTypeDef,
    FinalHyperParameterTuningJobObjectiveMetricTypeDef,
    FlowDefinitionSummaryTypeDef,
    GetDeviceFleetReportRequestRequestTypeDef,
    GetLineageGroupPolicyRequestRequestTypeDef,
    GetModelPackageGroupPolicyInputRequestTypeDef,
    PropertyNameSuggestionTypeDef,
    GitConfigForUpdateTypeDef,
    HubContentInfoTypeDef,
    HubInfoTypeDef,
    HumanLoopActivationConditionsConfigTypeDef,
    UiConfigTypeDef,
    HumanTaskUiSummaryTypeDef,
    HyperParameterTuningJobObjectiveTypeDef,
    HyperParameterTuningInstanceConfigTypeDef,
    ResourceLimitsTypeDef,
    HyperbandStrategyConfigTypeDef,
    ParentHyperParameterTuningJobTypeDef,
    IamIdentityTypeDef,
    RepositoryAuthConfigTypeDef,
    ImageTypeDef,
    ImageVersionTypeDef,
    RecommendationMetricsTypeDef,
    InferenceRecommendationsJobTypeDef,
    InstanceGroupTypeDef,
    IntegerParameterRangeSpecificationTypeDef,
    IntegerParameterRangeTypeDef,
    KernelSpecTypeDef,
    LabelCountersForWorkteamTypeDef,
    LabelingJobDataAttributesOutputTypeDef,
    LabelingJobDataAttributesTypeDef,
    LabelingJobS3DataSourceTypeDef,
    LabelingJobSnsDataSourceTypeDef,
    LineageGroupSummaryTypeDef,
    PaginatorConfigTypeDef,
    ListActionsRequestRequestTypeDef,
    ListAlgorithmsInputRequestTypeDef,
    ListAliasesRequestRequestTypeDef,
    ListAppImageConfigsRequestRequestTypeDef,
    ListAppsRequestRequestTypeDef,
    ListArtifactsRequestRequestTypeDef,
    ListAssociationsRequestRequestTypeDef,
    ListAutoMLJobsRequestRequestTypeDef,
    ListCandidatesForAutoMLJobRequestRequestTypeDef,
    ListCodeRepositoriesInputRequestTypeDef,
    ListCompilationJobsRequestRequestTypeDef,
    ListContextsRequestRequestTypeDef,
    ListDataQualityJobDefinitionsRequestRequestTypeDef,
    MonitoringJobDefinitionSummaryTypeDef,
    ListDeviceFleetsRequestRequestTypeDef,
    ListDevicesRequestRequestTypeDef,
    ListDomainsRequestRequestTypeDef,
    ListEdgeDeploymentPlansRequestRequestTypeDef,
    ListEdgePackagingJobsRequestRequestTypeDef,
    ListEndpointConfigsInputRequestTypeDef,
    ListEndpointsInputRequestTypeDef,
    ListExperimentsRequestRequestTypeDef,
    ListFeatureGroupsRequestRequestTypeDef,
    ListFlowDefinitionsRequestRequestTypeDef,
    ListHubContentVersionsRequestRequestTypeDef,
    ListHubContentsRequestRequestTypeDef,
    ListHubsRequestRequestTypeDef,
    ListHumanTaskUisRequestRequestTypeDef,
    ListHyperParameterTuningJobsRequestRequestTypeDef,
    ListImageVersionsRequestRequestTypeDef,
    ListImagesRequestRequestTypeDef,
    ListInferenceExperimentsRequestRequestTypeDef,
    ListInferenceRecommendationsJobStepsRequestRequestTypeDef,
    ListInferenceRecommendationsJobsRequestRequestTypeDef,
    ListLabelingJobsForWorkteamRequestRequestTypeDef,
    ListLabelingJobsRequestRequestTypeDef,
    ListLineageGroupsRequestRequestTypeDef,
    ListModelBiasJobDefinitionsRequestRequestTypeDef,
    ListModelCardExportJobsRequestRequestTypeDef,
    ModelCardExportJobSummaryTypeDef,
    ListModelCardVersionsRequestRequestTypeDef,
    ModelCardVersionSummaryTypeDef,
    ListModelCardsRequestRequestTypeDef,
    ModelCardSummaryTypeDef,
    ListModelExplainabilityJobDefinitionsRequestRequestTypeDef,
    ModelMetadataSummaryTypeDef,
    ListModelPackageGroupsInputRequestTypeDef,
    ModelPackageGroupSummaryTypeDef,
    ListModelPackagesInputRequestTypeDef,
    ModelPackageSummaryTypeDef,
    ListModelQualityJobDefinitionsRequestRequestTypeDef,
    ListModelsInputRequestTypeDef,
    ModelSummaryTypeDef,
    ListMonitoringAlertHistoryRequestRequestTypeDef,
    MonitoringAlertHistorySummaryTypeDef,
    ListMonitoringAlertsRequestRequestTypeDef,
    ListMonitoringExecutionsRequestRequestTypeDef,
    ListMonitoringSchedulesRequestRequestTypeDef,
    MonitoringScheduleSummaryTypeDef,
    ListNotebookInstanceLifecycleConfigsInputRequestTypeDef,
    NotebookInstanceLifecycleConfigSummaryTypeDef,
    ListNotebookInstancesInputRequestTypeDef,
    NotebookInstanceSummaryTypeDef,
    ListPipelineExecutionStepsRequestRequestTypeDef,
    ListPipelineExecutionsRequestRequestTypeDef,
    PipelineExecutionSummaryTypeDef,
    ListPipelineParametersForExecutionRequestRequestTypeDef,
    ParameterTypeDef,
    ListPipelinesRequestRequestTypeDef,
    PipelineSummaryTypeDef,
    ListProcessingJobsRequestRequestTypeDef,
    ProcessingJobSummaryTypeDef,
    ListProjectsInputRequestTypeDef,
    ProjectSummaryTypeDef,
    ListResourceCatalogsRequestRequestTypeDef,
    ResourceCatalogTypeDef,
    ListSpacesRequestRequestTypeDef,
    SpaceDetailsTypeDef,
    ListStageDevicesRequestRequestTypeDef,
    ListStudioLifecycleConfigsRequestRequestTypeDef,
    StudioLifecycleConfigDetailsTypeDef,
    ListSubscribedWorkteamsRequestRequestTypeDef,
    ListTagsInputRequestTypeDef,
    ListTrainingJobsForHyperParameterTuningJobRequestRequestTypeDef,
    ListTrainingJobsRequestRequestTypeDef,
    ListTransformJobsRequestRequestTypeDef,
    TransformJobSummaryTypeDef,
    ListTrialComponentsRequestRequestTypeDef,
    ListTrialsRequestRequestTypeDef,
    ListUserProfilesRequestRequestTypeDef,
    UserProfileDetailsTypeDef,
    ListWorkforcesRequestRequestTypeDef,
    ListWorkteamsRequestRequestTypeDef,
    OidcMemberDefinitionOutputTypeDef,
    OidcMemberDefinitionTypeDef,
    MonitoringGroundTruthS3InputTypeDef,
    ModelDashboardEndpointTypeDef,
    ModelDashboardIndicatorActionTypeDef,
    S3ModelDataSourceTypeDef,
    RealTimeInferenceConfigTypeDef,
    ModelInputTypeDef,
    ModelLatencyThresholdTypeDef,
    ModelMetadataFilterTypeDef,
    ModelPackageStatusItemTypeDef,
    ModelStepMetadataTypeDef,
    MonitoringAppSpecificationOutputTypeDef,
    MonitoringAppSpecificationTypeDef,
    MonitoringClusterConfigTypeDef,
    MonitoringCsvDatasetFormatTypeDef,
    MonitoringJsonDatasetFormatTypeDef,
    MonitoringS3OutputTypeDef,
    ScheduleConfigTypeDef,
    S3StorageConfigTypeDef,
    OidcConfigForResponseTypeDef,
    OnlineStoreSecurityConfigTypeDef,
    TtlDurationTypeDef,
    TargetPlatformTypeDef,
    ParentTypeDef,
    ProductionVariantStatusTypeDef,
    PhaseTypeDef,
    ProcessingJobStepMetadataTypeDef,
    QualityCheckStepMetadataTypeDef,
    RegisterModelStepMetadataTypeDef,
    TrainingJobStepMetadataTypeDef,
    TransformJobStepMetadataTypeDef,
    TuningJobStepMetaDataTypeDef,
    SelectiveExecutionResultTypeDef,
    ProcessingClusterConfigTypeDef,
    ProcessingFeatureStoreOutputTypeDef,
    ProcessingS3InputTypeDef,
    ProcessingS3OutputTypeDef,
    ProductionVariantCoreDumpConfigTypeDef,
    ProfilerConfigForUpdateTypeDef,
    PropertyNameQueryTypeDef,
    ProvisioningParameterTypeDef,
    USDTypeDef,
    PutModelPackageGroupPolicyInputRequestTypeDef,
    QueryFiltersTypeDef,
    VertexTypeDef,
    RStudioServerProAppSettingsTypeDef,
    RecommendationJobCompiledOutputConfigTypeDef,
    RecommendationJobPayloadConfigOutputTypeDef,
    RecommendationJobPayloadConfigTypeDef,
    RecommendationJobResourceLimitTypeDef,
    RecommendationJobVpcConfigOutputTypeDef,
    RecommendationJobVpcConfigTypeDef,
    RenderableTaskTypeDef,
    RenderingErrorTypeDef,
    ResourceConfigForUpdateTypeDef,
    SearchRequestRequestTypeDef,
    SelectedStepTypeDef,
    SendPipelineExecutionStepFailureRequestRequestTypeDef,
    ShadowModelVariantConfigTypeDef,
    SharingSettingsTypeDef,
    SourceAlgorithmTypeDef,
    SourceIpConfigOutputTypeDef,
    StartEdgeDeploymentStageRequestRequestTypeDef,
    StartInferenceExperimentRequestRequestTypeDef,
    StartMonitoringScheduleRequestRequestTypeDef,
    StartNotebookInstanceInputRequestTypeDef,
    StopAutoMLJobRequestRequestTypeDef,
    StopCompilationJobRequestRequestTypeDef,
    StopEdgeDeploymentStageRequestRequestTypeDef,
    StopEdgePackagingJobRequestRequestTypeDef,
    StopHyperParameterTuningJobRequestRequestTypeDef,
    StopInferenceRecommendationsJobRequestRequestTypeDef,
    StopLabelingJobRequestRequestTypeDef,
    StopMonitoringScheduleRequestRequestTypeDef,
    StopNotebookInstanceInputRequestTypeDef,
    StopPipelineExecutionRequestRequestTypeDef,
    StopProcessingJobRequestRequestTypeDef,
    StopTrainingJobRequestRequestTypeDef,
    StopTransformJobRequestRequestTypeDef,
    TimeSeriesConfigOutputTypeDef,
    TimeSeriesConfigTypeDef,
    TimeSeriesTransformationsOutputTypeDef,
    TimeSeriesTransformationsTypeDef,
    TrainingRepositoryAuthConfigTypeDef,
    TransformS3DataSourceTypeDef,
    UpdateActionRequestRequestTypeDef,
    UpdateArtifactRequestRequestTypeDef,
    UpdateContextRequestRequestTypeDef,
    VariantPropertyTypeDef,
    UpdateExperimentRequestRequestTypeDef,
    UpdateHubRequestRequestTypeDef,
    UpdateImageRequestRequestTypeDef,
    UpdateImageVersionRequestRequestTypeDef,
    UpdateModelCardRequestRequestTypeDef,
    UpdateMonitoringAlertRequestRequestTypeDef,
    UpdateTrialRequestRequestTypeDef,
    WorkforceVpcConfigResponseTypeDef,
    ActionSummaryTypeDef,
    AddAssociationResponseTypeDef,
    AssociateTrialComponentResponseTypeDef,
    CreateActionResponseTypeDef,
    CreateAlgorithmOutputTypeDef,
    CreateAppImageConfigResponseTypeDef,
    CreateAppResponseTypeDef,
    CreateArtifactResponseTypeDef,
    CreateAutoMLJobResponseTypeDef,
    CreateAutoMLJobV2ResponseTypeDef,
    CreateCodeRepositoryOutputTypeDef,
    CreateCompilationJobResponseTypeDef,
    CreateContextResponseTypeDef,
    CreateDataQualityJobDefinitionResponseTypeDef,
    CreateDomainResponseTypeDef,
    CreateEdgeDeploymentPlanResponseTypeDef,
    CreateEndpointConfigOutputTypeDef,
    CreateEndpointOutputTypeDef,
    CreateExperimentResponseTypeDef,
    CreateFeatureGroupResponseTypeDef,
    CreateFlowDefinitionResponseTypeDef,
    CreateHubResponseTypeDef,
    CreateHumanTaskUiResponseTypeDef,
    CreateHyperParameterTuningJobResponseTypeDef,
    CreateImageResponseTypeDef,
    CreateImageVersionResponseTypeDef,
    CreateInferenceExperimentResponseTypeDef,
    CreateInferenceRecommendationsJobResponseTypeDef,
    CreateLabelingJobResponseTypeDef,
    CreateModelBiasJobDefinitionResponseTypeDef,
    CreateModelCardExportJobResponseTypeDef,
    CreateModelCardResponseTypeDef,
    CreateModelExplainabilityJobDefinitionResponseTypeDef,
    CreateModelOutputTypeDef,
    CreateModelPackageGroupOutputTypeDef,
    CreateModelPackageOutputTypeDef,
    CreateModelQualityJobDefinitionResponseTypeDef,
    CreateMonitoringScheduleResponseTypeDef,
    CreateNotebookInstanceLifecycleConfigOutputTypeDef,
    CreateNotebookInstanceOutputTypeDef,
    CreatePipelineResponseTypeDef,
    CreatePresignedDomainUrlResponseTypeDef,
    CreatePresignedNotebookInstanceUrlOutputTypeDef,
    CreateProcessingJobResponseTypeDef,
    CreateProjectOutputTypeDef,
    CreateSpaceResponseTypeDef,
    CreateStudioLifecycleConfigResponseTypeDef,
    CreateTrainingJobResponseTypeDef,
    CreateTransformJobResponseTypeDef,
    CreateTrialComponentResponseTypeDef,
    CreateTrialResponseTypeDef,
    CreateUserProfileResponseTypeDef,
    CreateWorkforceResponseTypeDef,
    CreateWorkteamResponseTypeDef,
    DeleteActionResponseTypeDef,
    DeleteArtifactResponseTypeDef,
    DeleteAssociationResponseTypeDef,
    DeleteContextResponseTypeDef,
    DeleteExperimentResponseTypeDef,
    DeleteInferenceExperimentResponseTypeDef,
    DeletePipelineResponseTypeDef,
    DeleteTrialComponentResponseTypeDef,
    DeleteTrialResponseTypeDef,
    DeleteWorkteamResponseTypeDef,
    DescribeImageResponseTypeDef,
    DescribeImageVersionResponseTypeDef,
    DescribePipelineDefinitionForExecutionResponseTypeDef,
    DescribeStudioLifecycleConfigResponseTypeDef,
    DisassociateTrialComponentResponseTypeDef,
    EmptyResponseMetadataTypeDef,
    GetLineageGroupPolicyResponseTypeDef,
    GetModelPackageGroupPolicyOutputTypeDef,
    GetSagemakerServicecatalogPortfolioStatusOutputTypeDef,
    ImportHubContentResponseTypeDef,
    ListAliasesResponseTypeDef,
    PutModelPackageGroupPolicyOutputTypeDef,
    RetryPipelineExecutionResponseTypeDef,
    SendPipelineExecutionStepFailureResponseTypeDef,
    SendPipelineExecutionStepSuccessResponseTypeDef,
    StartInferenceExperimentResponseTypeDef,
    StartPipelineExecutionResponseTypeDef,
    StopInferenceExperimentResponseTypeDef,
    StopPipelineExecutionResponseTypeDef,
    UpdateActionResponseTypeDef,
    UpdateAppImageConfigResponseTypeDef,
    UpdateArtifactResponseTypeDef,
    UpdateCodeRepositoryOutputTypeDef,
    UpdateContextResponseTypeDef,
    UpdateDomainResponseTypeDef,
    UpdateEndpointOutputTypeDef,
    UpdateEndpointWeightsAndCapacitiesOutputTypeDef,
    UpdateExperimentResponseTypeDef,
    UpdateFeatureGroupResponseTypeDef,
    UpdateHubResponseTypeDef,
    UpdateImageResponseTypeDef,
    UpdateImageVersionResponseTypeDef,
    UpdateInferenceExperimentResponseTypeDef,
    UpdateModelCardResponseTypeDef,
    UpdateModelPackageOutputTypeDef,
    UpdateMonitoringAlertResponseTypeDef,
    UpdateMonitoringScheduleResponseTypeDef,
    UpdatePipelineExecutionResponseTypeDef,
    UpdatePipelineResponseTypeDef,
    UpdateProjectOutputTypeDef,
    UpdateSpaceResponseTypeDef,
    UpdateTrainingJobResponseTypeDef,
    UpdateTrialComponentResponseTypeDef,
    UpdateTrialResponseTypeDef,
    UpdateUserProfileResponseTypeDef,
    AddTagsInputRequestTypeDef,
    AddTagsOutputTypeDef,
    CreateExperimentRequestRequestTypeDef,
    CreateImageRequestRequestTypeDef,
    CreateModelPackageGroupInputRequestTypeDef,
    CreateStudioLifecycleConfigRequestRequestTypeDef,
    ImportHubContentRequestRequestTypeDef,
    ListTagsOutputTypeDef,
    AutoRollbackConfigOutputTypeDef,
    AutoRollbackConfigTypeDef,
    HyperParameterAlgorithmSpecificationOutputTypeDef,
    HyperParameterAlgorithmSpecificationTypeDef,
    AlgorithmStatusDetailsTypeDef,
    ListAlgorithmsOutputTypeDef,
    ListAppsResponseTypeDef,
    ArtifactSourceOutputTypeDef,
    ArtifactSourceTypeDef,
    AsyncInferenceOutputConfigOutputTypeDef,
    AsyncInferenceOutputConfigTypeDef,
    AutoMLCandidateGenerationConfigOutputTypeDef,
    CandidateGenerationConfigOutputTypeDef,
    AutoMLCandidateGenerationConfigTypeDef,
    CandidateGenerationConfigTypeDef,
    AutoMLDataSourceTypeDef,
    ImageClassificationJobConfigTypeDef,
    TextClassificationJobConfigTypeDef,
    ResolvedAttributesTypeDef,
    AutoMLJobSummaryTypeDef,
    AutoMLProblemTypeResolvedAttributesTypeDef,
    AutoMLSecurityConfigOutputTypeDef,
    LabelingJobResourceConfigOutputTypeDef,
    MonitoringNetworkConfigOutputTypeDef,
    NetworkConfigOutputTypeDef,
    AutoMLSecurityConfigTypeDef,
    LabelingJobResourceConfigTypeDef,
    MonitoringNetworkConfigTypeDef,
    NetworkConfigTypeDef,
    BiasTypeDef,
    DriftCheckModelDataQualityTypeDef,
    DriftCheckModelQualityTypeDef,
    ExplainabilityTypeDef,
    ModelDataQualityTypeDef,
    ModelQualityTypeDef,
    CallbackStepMetadataTypeDef,
    LambdaStepMetadataTypeDef,
    SendPipelineExecutionStepSuccessRequestRequestTypeDef,
    CandidatePropertiesTypeDef,
    CanvasAppSettingsTypeDef,
    RollingUpdatePolicyTypeDef,
    TrafficRoutingConfigTypeDef,
    InferenceExperimentDataStorageConfigOutputTypeDef,
    InferenceExperimentDataStorageConfigTypeDef,
    DataCaptureConfigOutputTypeDef,
    DataCaptureConfigTypeDef,
    EnvironmentParameterRangesOutputTypeDef,
    EnvironmentParameterRangesTypeDef,
    ClarifyShapConfigTypeDef,
    CodeRepositorySummaryTypeDef,
    CreateCodeRepositoryInputRequestTypeDef,
    DescribeCodeRepositoryOutputTypeDef,
    DebugHookConfigOutputTypeDef,
    DebugHookConfigTypeDef,
    ListCompilationJobsResponseTypeDef,
    ContextSummaryTypeDef,
    CreateContextRequestRequestTypeDef,
    TuningJobCompletionCriteriaTypeDef,
    CreateActionRequestRequestTypeDef,
    CreateTrialRequestRequestTypeDef,
    CreateAppRequestRequestTypeDef,
    DescribeAppResponseTypeDef,
    JupyterServerAppSettingsOutputTypeDef,
    JupyterServerAppSettingsTypeDef,
    RStudioServerProDomainSettingsForUpdateTypeDef,
    RStudioServerProDomainSettingsTypeDef,
    TensorBoardAppSettingsTypeDef,
    CreateDeviceFleetRequestRequestTypeDef,
    CreateEdgePackagingJobRequestRequestTypeDef,
    DescribeDeviceFleetResponseTypeDef,
    UpdateDeviceFleetRequestRequestTypeDef,
    CreateHubRequestRequestTypeDef,
    DescribeHubResponseTypeDef,
    CreateHumanTaskUiRequestRequestTypeDef,
    CreateModelCardExportJobRequestRequestTypeDef,
    CreateModelCardRequestRequestTypeDef,
    CreateNotebookInstanceInputRequestTypeDef,
    DescribeNotebookInstanceOutputTypeDef,
    UpdateNotebookInstanceInputRequestTypeDef,
    CreateNotebookInstanceLifecycleConfigInputRequestTypeDef,
    DescribeNotebookInstanceLifecycleConfigOutputTypeDef,
    UpdateNotebookInstanceLifecycleConfigInputRequestTypeDef,
    RetryPipelineExecutionRequestRequestTypeDef,
    UpdatePipelineExecutionRequestRequestTypeDef,
    CreatePipelineRequestRequestTypeDef,
    UpdatePipelineRequestRequestTypeDef,
    CreateTrialComponentRequestRequestTypeDef,
    UpdateTrialComponentRequestRequestTypeDef,
    CreateWorkforceRequestRequestTypeDef,
    UpdateWorkforceRequestRequestTypeDef,
    KernelGatewayAppSettingsOutputTypeDef,
    KernelGatewayAppSettingsTypeDef,
    RSessionAppSettingsOutputTypeDef,
    RSessionAppSettingsTypeDef,
    ModelBiasBaselineConfigTypeDef,
    ModelExplainabilityBaselineConfigTypeDef,
    ModelQualityBaselineConfigTypeDef,
    DataQualityBaselineConfigTypeDef,
    MonitoringBaselineConfigTypeDef,
    DataSourceOutputTypeDef,
    DataSourceTypeDef,
    DatasetDefinitionTypeDef,
    DeleteDomainRequestRequestTypeDef,
    DeploymentRecommendationTypeDef,
    DeploymentStageStatusSummaryTypeDef,
    DeploymentStageTypeDef,
    DescribeDeviceResponseTypeDef,
    DescribeEdgePackagingJobResponseTypeDef,
    DescribeEndpointInputEndpointDeletedWaitTypeDef,
    DescribeEndpointInputEndpointInServiceWaitTypeDef,
    DescribeImageRequestImageCreatedWaitTypeDef,
    DescribeImageRequestImageDeletedWaitTypeDef,
    DescribeImageRequestImageUpdatedWaitTypeDef,
    DescribeImageVersionRequestImageVersionCreatedWaitTypeDef,
    DescribeImageVersionRequestImageVersionDeletedWaitTypeDef,
    DescribeNotebookInstanceInputNotebookInstanceDeletedWaitTypeDef,
    DescribeNotebookInstanceInputNotebookInstanceInServiceWaitTypeDef,
    DescribeNotebookInstanceInputNotebookInstanceStoppedWaitTypeDef,
    DescribeProcessingJobRequestProcessingJobCompletedOrStoppedWaitTypeDef,
    DescribeTrainingJobRequestTrainingJobCompletedOrStoppedWaitTypeDef,
    DescribeTransformJobRequestTransformJobCompletedOrStoppedWaitTypeDef,
    ExperimentSummaryTypeDef,
    FeatureGroupSummaryTypeDef,
    DescribeFeatureMetadataResponseTypeDef,
    FeatureMetadataTypeDef,
    UpdateFeatureMetadataRequestRequestTypeDef,
    DescribeHubContentResponseTypeDef,
    DescribeHumanTaskUiResponseTypeDef,
    InferenceExperimentSummaryTypeDef,
    DescribeModelCardExportJobResponseTypeDef,
    ListMonitoringExecutionsResponseTypeDef,
    DescribeSubscribedWorkteamResponseTypeDef,
    ListSubscribedWorkteamsResponseTypeDef,
    TrainingJobSummaryTypeDef,
    TrialSummaryTypeDef,
    DesiredWeightAndCapacityTypeDef,
    ListStageDevicesResponseTypeDef,
    ListDeviceFleetsResponseTypeDef,
    DeviceSummaryTypeDef,
    RegisterDevicesRequestRequestTypeDef,
    UpdateDevicesRequestRequestTypeDef,
    ListDomainsResponseTypeDef,
    DriftCheckBiasTypeDef,
    DriftCheckExplainabilityTypeDef,
    ListEdgeDeploymentPlansResponseTypeDef,
    GetDeviceFleetReportResponseTypeDef,
    ListEdgePackagingJobsResponseTypeDef,
    ListEndpointConfigsOutputTypeDef,
    EndpointOutputConfigurationTypeDef,
    EndpointPerformanceTypeDef,
    ListEndpointsOutputTypeDef,
    ModelConfigurationTypeDef,
    NestedFiltersTypeDef,
    HyperParameterTrainingJobSummaryTypeDef,
    ListFlowDefinitionsResponseTypeDef,
    GetSearchSuggestionsResponseTypeDef,
    UpdateCodeRepositoryInputRequestTypeDef,
    ListHubContentVersionsResponseTypeDef,
    ListHubContentsResponseTypeDef,
    ListHubsResponseTypeDef,
    HumanLoopActivationConfigTypeDef,
    ListHumanTaskUisResponseTypeDef,
    HyperParameterTuningResourceConfigOutputTypeDef,
    HyperParameterTuningResourceConfigTypeDef,
    HyperParameterTuningJobSummaryTypeDef,
    HyperParameterTuningJobStrategyConfigTypeDef,
    HyperParameterTuningJobWarmStartConfigOutputTypeDef,
    HyperParameterTuningJobWarmStartConfigTypeDef,
    UserContextTypeDef,
    ImageConfigTypeDef,
    ListImagesResponseTypeDef,
    ListImageVersionsResponseTypeDef,
    ListInferenceRecommendationsJobsResponseTypeDef,
    ResourceConfigOutputTypeDef,
    ResourceConfigTypeDef,
    ParameterRangeOutputTypeDef,
    ParameterRangeTypeDef,
    ParameterRangesOutputTypeDef,
    ParameterRangesTypeDef,
    KernelGatewayImageConfigOutputTypeDef,
    KernelGatewayImageConfigTypeDef,
    LabelingJobForWorkteamSummaryTypeDef,
    LabelingJobDataSourceTypeDef,
    ListLineageGroupsResponseTypeDef,
    ListActionsRequestListActionsPaginateTypeDef,
    ListAlgorithmsInputListAlgorithmsPaginateTypeDef,
    ListAliasesRequestListAliasesPaginateTypeDef,
    ListAppImageConfigsRequestListAppImageConfigsPaginateTypeDef,
    ListAppsRequestListAppsPaginateTypeDef,
    ListArtifactsRequestListArtifactsPaginateTypeDef,
    ListAssociationsRequestListAssociationsPaginateTypeDef,
    ListAutoMLJobsRequestListAutoMLJobsPaginateTypeDef,
    ListCandidatesForAutoMLJobRequestListCandidatesForAutoMLJobPaginateTypeDef,
    ListCodeRepositoriesInputListCodeRepositoriesPaginateTypeDef,
    ListCompilationJobsRequestListCompilationJobsPaginateTypeDef,
    ListContextsRequestListContextsPaginateTypeDef,
    ListDataQualityJobDefinitionsRequestListDataQualityJobDefinitionsPaginateTypeDef,
    ListDeviceFleetsRequestListDeviceFleetsPaginateTypeDef,
    ListDevicesRequestListDevicesPaginateTypeDef,
    ListDomainsRequestListDomainsPaginateTypeDef,
    ListEdgeDeploymentPlansRequestListEdgeDeploymentPlansPaginateTypeDef,
    ListEdgePackagingJobsRequestListEdgePackagingJobsPaginateTypeDef,
    ListEndpointConfigsInputListEndpointConfigsPaginateTypeDef,
    ListEndpointsInputListEndpointsPaginateTypeDef,
    ListExperimentsRequestListExperimentsPaginateTypeDef,
    ListFeatureGroupsRequestListFeatureGroupsPaginateTypeDef,
    ListFlowDefinitionsRequestListFlowDefinitionsPaginateTypeDef,
    ListHumanTaskUisRequestListHumanTaskUisPaginateTypeDef,
    ListHyperParameterTuningJobsRequestListHyperParameterTuningJobsPaginateTypeDef,
    ListImageVersionsRequestListImageVersionsPaginateTypeDef,
    ListImagesRequestListImagesPaginateTypeDef,
    ListInferenceExperimentsRequestListInferenceExperimentsPaginateTypeDef,
    ListInferenceRecommendationsJobStepsRequestListInferenceRecommendationsJobStepsPaginateTypeDef,
    ListInferenceRecommendationsJobsRequestListInferenceRecommendationsJobsPaginateTypeDef,
    ListLabelingJobsForWorkteamRequestListLabelingJobsForWorkteamPaginateTypeDef,
    ListLabelingJobsRequestListLabelingJobsPaginateTypeDef,
    ListLineageGroupsRequestListLineageGroupsPaginateTypeDef,
    ListModelBiasJobDefinitionsRequestListModelBiasJobDefinitionsPaginateTypeDef,
    ListModelCardExportJobsRequestListModelCardExportJobsPaginateTypeDef,
    ListModelCardVersionsRequestListModelCardVersionsPaginateTypeDef,
    ListModelCardsRequestListModelCardsPaginateTypeDef,
    ListModelExplainabilityJobDefinitionsRequestListModelExplainabilityJobDefinitionsPaginateTypeDef,
    ListModelPackageGroupsInputListModelPackageGroupsPaginateTypeDef,
    ListModelPackagesInputListModelPackagesPaginateTypeDef,
    ListModelQualityJobDefinitionsRequestListModelQualityJobDefinitionsPaginateTypeDef,
    ListModelsInputListModelsPaginateTypeDef,
    ListMonitoringAlertHistoryRequestListMonitoringAlertHistoryPaginateTypeDef,
    ListMonitoringAlertsRequestListMonitoringAlertsPaginateTypeDef,
    ListMonitoringExecutionsRequestListMonitoringExecutionsPaginateTypeDef,
    ListMonitoringSchedulesRequestListMonitoringSchedulesPaginateTypeDef,
    ListNotebookInstanceLifecycleConfigsInputListNotebookInstanceLifecycleConfigsPaginateTypeDef,
    ListNotebookInstancesInputListNotebookInstancesPaginateTypeDef,
    ListPipelineExecutionStepsRequestListPipelineExecutionStepsPaginateTypeDef,
    ListPipelineExecutionsRequestListPipelineExecutionsPaginateTypeDef,
    ListPipelineParametersForExecutionRequestListPipelineParametersForExecutionPaginateTypeDef,
    ListPipelinesRequestListPipelinesPaginateTypeDef,
    ListProcessingJobsRequestListProcessingJobsPaginateTypeDef,
    ListResourceCatalogsRequestListResourceCatalogsPaginateTypeDef,
    ListSpacesRequestListSpacesPaginateTypeDef,
    ListStageDevicesRequestListStageDevicesPaginateTypeDef,
    ListStudioLifecycleConfigsRequestListStudioLifecycleConfigsPaginateTypeDef,
    ListSubscribedWorkteamsRequestListSubscribedWorkteamsPaginateTypeDef,
    ListTagsInputListTagsPaginateTypeDef,
    ListTrainingJobsForHyperParameterTuningJobRequestListTrainingJobsForHyperParameterTuningJobPaginateTypeDef,
    ListTrainingJobsRequestListTrainingJobsPaginateTypeDef,
    ListTransformJobsRequestListTransformJobsPaginateTypeDef,
    ListTrialComponentsRequestListTrialComponentsPaginateTypeDef,
    ListTrialsRequestListTrialsPaginateTypeDef,
    ListUserProfilesRequestListUserProfilesPaginateTypeDef,
    ListWorkforcesRequestListWorkforcesPaginateTypeDef,
    ListWorkteamsRequestListWorkteamsPaginateTypeDef,
    SearchRequestSearchPaginateTypeDef,
    ListDataQualityJobDefinitionsResponseTypeDef,
    ListModelBiasJobDefinitionsResponseTypeDef,
    ListModelExplainabilityJobDefinitionsResponseTypeDef,
    ListModelQualityJobDefinitionsResponseTypeDef,
    ListModelCardExportJobsResponseTypeDef,
    ListModelCardVersionsResponseTypeDef,
    ListModelCardsResponseTypeDef,
    ListModelMetadataResponseTypeDef,
    ListModelPackageGroupsOutputTypeDef,
    ListModelPackagesOutputTypeDef,
    ListModelsOutputTypeDef,
    ListMonitoringAlertHistoryResponseTypeDef,
    ListMonitoringSchedulesResponseTypeDef,
    ListNotebookInstanceLifecycleConfigsOutputTypeDef,
    ListNotebookInstancesOutputTypeDef,
    ListPipelineExecutionsResponseTypeDef,
    ListPipelineParametersForExecutionResponseTypeDef,
    ListPipelinesResponseTypeDef,
    ListProcessingJobsResponseTypeDef,
    ListProjectsOutputTypeDef,
    ListResourceCatalogsResponseTypeDef,
    ListSpacesResponseTypeDef,
    ListStudioLifecycleConfigsResponseTypeDef,
    ListTransformJobsResponseTypeDef,
    ListUserProfilesResponseTypeDef,
    MemberDefinitionOutputTypeDef,
    MemberDefinitionTypeDef,
    MonitoringAlertActionsTypeDef,
    ModelDataSourceTypeDef,
    ModelInfrastructureConfigTypeDef,
    ModelPackageContainerDefinitionOutputTypeDef,
    ModelPackageContainerDefinitionTypeDef,
    RecommendationJobStoppingConditionsOutputTypeDef,
    RecommendationJobStoppingConditionsTypeDef,
    ModelMetadataSearchExpressionTypeDef,
    ModelPackageStatusDetailsTypeDef,
    MonitoringResourcesTypeDef,
    MonitoringDatasetFormatOutputTypeDef,
    MonitoringDatasetFormatTypeDef,
    MonitoringOutputTypeDef,
    OfflineStoreConfigTypeDef,
    OnlineStoreConfigTypeDef,
    OnlineStoreConfigUpdateTypeDef,
    OutputConfigTypeDef,
    PendingProductionVariantSummaryTypeDef,
    ProductionVariantSummaryTypeDef,
    TrafficPatternOutputTypeDef,
    TrafficPatternTypeDef,
    ProcessingResourcesTypeDef,
    ProcessingOutputTypeDef,
    ProductionVariantTypeDef,
    SuggestionQueryTypeDef,
    ServiceCatalogProvisioningDetailsOutputTypeDef,
    ServiceCatalogProvisioningDetailsTypeDef,
    ServiceCatalogProvisioningUpdateDetailsTypeDef,
    PublicWorkforceTaskPriceTypeDef,
    QueryLineageRequestRequestTypeDef,
    QueryLineageResponseTypeDef,
    RecommendationJobOutputConfigTypeDef,
    RecommendationJobContainerConfigOutputTypeDef,
    RecommendationJobContainerConfigTypeDef,
    RenderUiTemplateRequestRequestTypeDef,
    RenderUiTemplateResponseTypeDef,
    UpdateTrainingJobRequestRequestTypeDef,
    SelectiveExecutionConfigOutputTypeDef,
    SelectiveExecutionConfigTypeDef,
    ShadowModeConfigOutputTypeDef,
    ShadowModeConfigTypeDef,
    SourceAlgorithmSpecificationOutputTypeDef,
    SourceAlgorithmSpecificationTypeDef,
    TimeSeriesForecastingJobConfigOutputTypeDef,
    TimeSeriesForecastingJobConfigTypeDef,
    TrainingImageConfigTypeDef,
    TransformDataSourceTypeDef,
    WorkforceTypeDef,
    ListActionsResponseTypeDef,
    ArtifactSummaryTypeDef,
    CreateArtifactRequestRequestTypeDef,
    DeleteArtifactRequestRequestTypeDef,
    AsyncInferenceConfigOutputTypeDef,
    AsyncInferenceConfigTypeDef,
    TabularJobConfigOutputTypeDef,
    TabularJobConfigTypeDef,
    AutoMLChannelTypeDef,
    AutoMLJobChannelTypeDef,
    ListAutoMLJobsResponseTypeDef,
    AutoMLResolvedAttributesTypeDef,
    AutoMLJobConfigOutputTypeDef,
    LabelingJobAlgorithmsConfigOutputTypeDef,
    AutoMLJobConfigTypeDef,
    LabelingJobAlgorithmsConfigTypeDef,
    ModelMetricsTypeDef,
    PipelineExecutionStepMetadataTypeDef,
    AutoMLCandidateTypeDef,
    BlueGreenUpdatePolicyTypeDef,
    EndpointInputConfigurationOutputTypeDef,
    EndpointInputConfigurationTypeDef,
    ClarifyExplainerConfigOutputTypeDef,
    ClarifyExplainerConfigTypeDef,
    ListCodeRepositoriesOutputTypeDef,
    ListContextsResponseTypeDef,
    DomainSettingsForUpdateTypeDef,
    DomainSettingsOutputTypeDef,
    DomainSettingsTypeDef,
    DefaultSpaceSettingsOutputTypeDef,
    SpaceSettingsOutputTypeDef,
    DefaultSpaceSettingsTypeDef,
    SpaceSettingsTypeDef,
    UserSettingsOutputTypeDef,
    UserSettingsTypeDef,
    ChannelOutputTypeDef,
    ChannelTypeDef,
    ProcessingInputTypeDef,
    DescribeEdgeDeploymentPlanResponseTypeDef,
    CreateEdgeDeploymentPlanRequestRequestTypeDef,
    CreateEdgeDeploymentStageRequestRequestTypeDef,
    ListExperimentsResponseTypeDef,
    ListFeatureGroupsResponseTypeDef,
    ListInferenceExperimentsResponseTypeDef,
    ListTrainingJobsResponseTypeDef,
    ListTrialsResponseTypeDef,
    UpdateEndpointWeightsAndCapacitiesInputRequestTypeDef,
    ListDevicesResponseTypeDef,
    DriftCheckBaselinesTypeDef,
    InferenceRecommendationTypeDef,
    RecommendationJobInferenceBenchmarkTypeDef,
    SearchExpressionTypeDef,
    ListTrainingJobsForHyperParameterTuningJobResponseTypeDef,
    ListHyperParameterTuningJobsResponseTypeDef,
    AssociationSummaryTypeDef,
    DescribeActionResponseTypeDef,
    DescribeArtifactResponseTypeDef,
    DescribeContextResponseTypeDef,
    DescribeExperimentResponseTypeDef,
    DescribeLineageGroupResponseTypeDef,
    DescribeModelCardResponseTypeDef,
    DescribeModelPackageGroupOutputTypeDef,
    DescribePipelineResponseTypeDef,
    DescribeTrialComponentResponseTypeDef,
    DescribeTrialResponseTypeDef,
    ExperimentTypeDef,
    ModelCardTypeDef,
    ModelDashboardModelCardTypeDef,
    ModelPackageGroupTypeDef,
    PipelineTypeDef,
    TrialComponentSimpleSummaryTypeDef,
    TrialComponentSummaryTypeDef,
    HyperParameterSpecificationOutputTypeDef,
    HyperParameterSpecificationTypeDef,
    HyperParameterTuningJobConfigOutputTypeDef,
    HyperParameterTuningJobConfigTypeDef,
    AppImageConfigDetailsTypeDef,
    DescribeAppImageConfigResponseTypeDef,
    CreateAppImageConfigRequestRequestTypeDef,
    UpdateAppImageConfigRequestRequestTypeDef,
    ListLabelingJobsForWorkteamResponseTypeDef,
    LabelingJobInputConfigOutputTypeDef,
    LabelingJobInputConfigTypeDef,
    WorkteamTypeDef,
    CreateWorkteamRequestRequestTypeDef,
    UpdateWorkteamRequestRequestTypeDef,
    MonitoringAlertSummaryTypeDef,
    ContainerDefinitionOutputTypeDef,
    ContainerDefinitionTypeDef,
    ModelVariantConfigSummaryTypeDef,
    ModelVariantConfigTypeDef,
    AdditionalInferenceSpecificationDefinitionOutputTypeDef,
    InferenceSpecificationOutputTypeDef,
    AdditionalInferenceSpecificationDefinitionTypeDef,
    InferenceSpecificationTypeDef,
    ListModelMetadataRequestListModelMetadataPaginateTypeDef,
    ListModelMetadataRequestRequestTypeDef,
    BatchTransformInputOutputTypeDef,
    BatchTransformInputTypeDef,
    MonitoringOutputConfigOutputTypeDef,
    MonitoringOutputConfigTypeDef,
    CreateFeatureGroupRequestRequestTypeDef,
    DescribeFeatureGroupResponseTypeDef,
    FeatureGroupTypeDef,
    UpdateFeatureGroupRequestRequestTypeDef,
    CreateCompilationJobRequestRequestTypeDef,
    DescribeCompilationJobResponseTypeDef,
    PendingDeploymentSummaryTypeDef,
    ProcessingOutputConfigOutputTypeDef,
    ProcessingOutputConfigTypeDef,
    GetSearchSuggestionsRequestRequestTypeDef,
    DescribeProjectOutputTypeDef,
    ProjectTypeDef,
    CreateProjectInputRequestTypeDef,
    UpdateProjectInputRequestTypeDef,
    HumanLoopConfigOutputTypeDef,
    HumanLoopConfigTypeDef,
    HumanTaskConfigOutputTypeDef,
    HumanTaskConfigTypeDef,
    DescribePipelineExecutionResponseTypeDef,
    PipelineExecutionTypeDef,
    StartPipelineExecutionRequestRequestTypeDef,
    AlgorithmSpecificationOutputTypeDef,
    AlgorithmSpecificationTypeDef,
    TransformInputTypeDef,
    DescribeWorkforceResponseTypeDef,
    ListWorkforcesResponseTypeDef,
    UpdateWorkforceResponseTypeDef,
    ListArtifactsResponseTypeDef,
    AutoMLProblemTypeConfigOutputTypeDef,
    AutoMLProblemTypeConfigTypeDef,
    CreateAutoMLJobRequestRequestTypeDef,
    PipelineExecutionStepTypeDef,
    DescribeAutoMLJobResponseTypeDef,
    ListCandidatesForAutoMLJobResponseTypeDef,
    DeploymentConfigOutputTypeDef,
    DeploymentConfigTypeDef,
    RecommendationJobInputConfigOutputTypeDef,
    RecommendationJobInputConfigTypeDef,
    ExplainerConfigOutputTypeDef,
    ExplainerConfigTypeDef,
    DescribeSpaceResponseTypeDef,
    CreateSpaceRequestRequestTypeDef,
    UpdateSpaceRequestRequestTypeDef,
    DescribeDomainResponseTypeDef,
    DescribeUserProfileResponseTypeDef,
    CreateDomainRequestRequestTypeDef,
    CreateUserProfileRequestRequestTypeDef,
    UpdateDomainRequestRequestTypeDef,
    UpdateUserProfileRequestRequestTypeDef,
    HyperParameterTrainingJobDefinitionOutputTypeDef,
    TrainingJobDefinitionOutputTypeDef,
    HyperParameterTrainingJobDefinitionTypeDef,
    TrainingJobDefinitionTypeDef,
    InferenceRecommendationsJobStepTypeDef,
    ListAssociationsResponseTypeDef,
    TrialTypeDef,
    ListTrialComponentsResponseTypeDef,
    TrainingSpecificationOutputTypeDef,
    TrainingSpecificationTypeDef,
    ListAppImageConfigsResponseTypeDef,
    LabelingJobSummaryTypeDef,
    DescribeWorkteamResponseTypeDef,
    ListWorkteamsResponseTypeDef,
    UpdateWorkteamResponseTypeDef,
    ListMonitoringAlertsResponseTypeDef,
    DescribeModelOutputTypeDef,
    ModelTypeDef,
    CreateModelInputRequestTypeDef,
    DescribeInferenceExperimentResponseTypeDef,
    CreateInferenceExperimentRequestRequestTypeDef,
    StopInferenceExperimentRequestRequestTypeDef,
    UpdateInferenceExperimentRequestRequestTypeDef,
    BatchDescribeModelPackageSummaryTypeDef,
    UpdateModelPackageInputRequestTypeDef,
    DataQualityJobInputOutputTypeDef,
    ModelBiasJobInputOutputTypeDef,
    ModelExplainabilityJobInputOutputTypeDef,
    ModelQualityJobInputOutputTypeDef,
    MonitoringInputOutputTypeDef,
    DataQualityJobInputTypeDef,
    ModelBiasJobInputTypeDef,
    ModelExplainabilityJobInputTypeDef,
    ModelQualityJobInputTypeDef,
    MonitoringInputTypeDef,
    DescribeProcessingJobResponseTypeDef,
    ProcessingJobTypeDef,
    CreateProcessingJobRequestRequestTypeDef,
    DescribeFlowDefinitionResponseTypeDef,
    CreateFlowDefinitionRequestRequestTypeDef,
    DescribeLabelingJobResponseTypeDef,
    CreateLabelingJobRequestRequestTypeDef,
    DescribeTrainingJobResponseTypeDef,
    TrainingJobTypeDef,
    CreateTrainingJobRequestRequestTypeDef,
    CreateTransformJobRequestRequestTypeDef,
    DescribeTransformJobResponseTypeDef,
    TransformJobDefinitionOutputTypeDef,
    TransformJobDefinitionTypeDef,
    TransformJobTypeDef,
    DescribeAutoMLJobV2ResponseTypeDef,
    CreateAutoMLJobV2RequestRequestTypeDef,
    ListPipelineExecutionStepsResponseTypeDef,
    CreateEndpointInputRequestTypeDef,
    UpdateEndpointInputRequestTypeDef,
    DescribeInferenceRecommendationsJobResponseTypeDef,
    CreateInferenceRecommendationsJobRequestRequestTypeDef,
    DescribeEndpointConfigOutputTypeDef,
    DescribeEndpointOutputTypeDef,
    CreateEndpointConfigInputRequestTypeDef,
    DescribeHyperParameterTuningJobResponseTypeDef,
    HyperParameterTuningJobSearchEntityTypeDef,
    CreateHyperParameterTuningJobRequestRequestTypeDef,
    ListInferenceRecommendationsJobStepsResponseTypeDef,
    ListLabelingJobsResponseTypeDef,
    BatchDescribeModelPackageOutputTypeDef,
    DescribeDataQualityJobDefinitionResponseTypeDef,
    DescribeModelBiasJobDefinitionResponseTypeDef,
    DescribeModelExplainabilityJobDefinitionResponseTypeDef,
    DescribeModelQualityJobDefinitionResponseTypeDef,
    MonitoringJobDefinitionOutputTypeDef,
    CreateDataQualityJobDefinitionRequestRequestTypeDef,
    CreateModelBiasJobDefinitionRequestRequestTypeDef,
    CreateModelExplainabilityJobDefinitionRequestRequestTypeDef,
    CreateModelQualityJobDefinitionRequestRequestTypeDef,
    MonitoringJobDefinitionTypeDef,
    AlgorithmValidationProfileOutputTypeDef,
    ModelPackageValidationProfileOutputTypeDef,
    AlgorithmValidationProfileTypeDef,
    ModelPackageValidationProfileTypeDef,
    TrialComponentSourceDetailTypeDef,
    MonitoringScheduleConfigOutputTypeDef,
    MonitoringScheduleConfigTypeDef,
    AlgorithmValidationSpecificationOutputTypeDef,
    ModelPackageValidationSpecificationOutputTypeDef,
    AlgorithmValidationSpecificationTypeDef,
    ModelPackageValidationSpecificationTypeDef,
    TrialComponentTypeDef,
    DescribeMonitoringScheduleResponseTypeDef,
    ModelDashboardMonitoringScheduleTypeDef,
    MonitoringScheduleTypeDef,
    CreateMonitoringScheduleRequestRequestTypeDef,
    UpdateMonitoringScheduleRequestRequestTypeDef,
    DescribeAlgorithmOutputTypeDef,
    DescribeModelPackageOutputTypeDef,
    ModelPackageTypeDef,
    CreateAlgorithmInputRequestTypeDef,
    CreateModelPackageInputRequestTypeDef,
    ModelDashboardModelTypeDef,
    EndpointTypeDef,
    SearchRecordTypeDef,
    SearchResponseTypeDef,
)


def get_structure() -> ActionSourceTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for `boto3`
updates. It delivers drop-in type annotations for you and makes sure that:

- All available `boto3` services are covered.
- Each public class and method of every `boto3` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`mypy-boto3-sagemaker` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[boto3 docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_sagemaker/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
